#include <stdio.h>
#include <omp.h>

int main (void) {
  int i, n;
  double area, pi, subarea, x;

  /* arbitrary */
  n = 40000000;

  area = 0.0;
#pragma omp parallel private(x, subarea)
  {
    subarea = 0.0;

#pragma omp for nowait
    for (i = 0; i < n; i++) {
      x = (i + 0.5) / n;
      subarea += 4.0 / (1.0 + x*x);
    }

#pragma omp critical
    area += subarea;
  }

  pi = area / n;
  printf("pi ~= %16.16f\n", pi);

  return 0;
}
